/*@ requires n >= 1 && \valid_read(a+(0..n-1));
    assigns \nothing;
    ensures \forall integer i; 0 <= i < n ==> a[\result] >= a[i];
*/ 
int max (int* a, int n) 
{ int m, i;
  
  m = 0;
  /*@ 
      loop assigns i, m;
      loop invariant
        1 <= i <= n;
      loop invariant
        \forall integer k; 0 <= k < i  ==> a[m] >= a[k];
  */
  for (i=1; i<n; i++)
    if (a[i] > a[m]) 
      m = i; 
  return m; 
} 
